HDU——1069 Monkey and Banana(DP)

Problem Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn’t be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format “Case case: maximum height = height”.

Sample Input

1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0

Sample Output

Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342

解题思路:

  每个长方体有6中不同的摆放方式 , 又因为每一种长方体块都是无限多个 , 多了也没用 , 每种取6个 , 代表不同的摆放方式 。
  排序 , 按照长度由小到大排 , 若长度相等 , 则按宽度由小到大排。
  然后就是找状态转移方程了。

代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

typedef struct{
    int l;
    int w;
    int h;
}Block;

Block blo[185];   //最多30中类型的长方形 , 每种可以有 6 个不同的摆放方法
int dp[185];
bool method(Block a , Block b){
    if(a.l != b.l)
        return a.l < b.l;
    else
        return a.w < b.w;
}

int max(int a , int b){
    if(a > b)
        return a;
    return b;
}
int main(){
    //freopen("D:\\testData\\1069.txt" , "r" , stdin);
    int n , i , j , x , y , z , len , k = 0;
    while(scanf("%d" , &n) != EOF && n){
        k ++;
        memset(dp , 0 , sizeof(dp));
        len = 0;
        for(i = 0 ; i < n ;i ++){
            scanf("%d %d %d",&x , &y , &z);
            blo[len].l = x ; blo[len].w = y ; blo[len++].h = z;
            blo[len].l = y ; blo[len].w = x ; blo[len++].h = z;
            blo[len].l = x ; blo[len].w = z ; blo[len++].h = y;
            blo[len].l = z ; blo[len].w = x ; blo[len++].h = y;
            blo[len].l = y ; blo[len].w = z ; blo[len++].h = x;
            blo[len].l = z ; blo[len].w = y ; blo[len++].h = x;
        }

        sort(blo , blo + len , method);    //从小到大排一下

        int maxheight = 0;
        for(i = 0 ; i < len ; i++){
            dp[i] = blo[i].h;
            for(j = 0 ; j < i ; j ++){
                if(blo[i].l > blo[j].l && blo[i].w > blo[j].w)
                    dp[i] = max(dp[i] , dp[j] + blo[i].h);  //找前面所能达到的最高高度
            }

            if(dp[i] > maxheight)
                maxheight = dp[i];
        }
        printf("Case %d: maximum height = %d\n" , k , maxheight);
    }
}

猜你喜欢

转载自blog.csdn.net/sinat_38052999/article/details/80053320